angular.module('MainApp', [])


function mainController($scope, $http) {
	$scope.newUsuari = {};
	$scope.usuaris = {};
	$scope.selected = false;

	// Obtenemos todos los datos de la base de datos
	$http.get('/api/usuari').success(function(data) {
		$scope.usuaris = data;
	})
	.error(function(data) {
		console.log('Error: ' + data);
	});


	// Función para registrar a una usuari
	$scope.registrarUsuari = function() {
		$http.post('/api/usuari', $scope.newUsuari)
		.success(function(data) {
				$scope.newUsuari = {};
				$scope.usuaris = data;
			})
		.error(function(data) {
			console.log('Error: ' + data);
		});
	};

	// Función para editar los datos de una usuari
	$scope.modificarUsuari = function(newUsuari) {
		$http.put('/api/usuari/' + $scope.newUsuari._id, $scope.newUsuari)
		.success(function(data) {
				$scope.newUsuari = {}; // Borramos los datos del formulario
				$scope.usuaris = data;
				$scope.selected = false;
			})
		.error(function(data) {
			console.log('Error: ' + data);
		});
	};

	// Función que borra un objeto usuari conocido su id
	$scope.borrarUsuari = function(newUsuari) {
		$http.delete('/api/usuari/' + $scope.newUsuari._id)
		.success(function(data) {
			$scope.newUsuari = {};
			$scope.usuaris = data;
			$scope.selected = false;
		})
		.error(function(data) {
			console.log('Error: ' + data);
		});
	};

	// Función para coger el objeto seleccionado en la tabla
	$scope.selectUsuari = function(usuari) {
		$scope.newUsuari = usuari;
		$scope.selected = true;
		console.log($scope.newUsuari, $scope.selected);
	};
}