var app = angular.module('MainApp', ['ngSanitize'])

/* Directiva de prova per provar $compile */


app.directive('dynamic', function ($compile) {
	return {
		restrict: 'A',
		replace: true,
		link: function (scope, ele, attrs) {
			scope.$watch(attrs.dynamic, function(html) {
				ele.html(html);
				$compile(ele.contents())(scope);
			});
		}
	};
});

app.directive("otcDynamic", function($compile){
	return{
		restrict: 'E',
		link: function(scope, element){
			var template =	'<button ng-mouseover="count = count + 1" ng-init="count=0">'+
			'		Dynamic : {{ plantillaActual.cos }} '+
			' </button> count: {{count}} ';
			var linkFn = $compile(template);
			var content = linkFn(scope);
			element.append(content);
		}
	}
});

// Directiva de prova per injectar codi amb parse. No es fa servir

app.directive('htmldiv', function($compile, $parse) {
	return {
		restrict: 'E',
		link: function(scope, element, attr) {
			scope.$watch(attr.content, function() {
				element.html($parse(attr.content)(scope));
				$compile(element.contents())(scope);
			}, true);
		}
	}
});



app.factory('srvPlantilles', function ()
{
    var func;

	return {
		set : function(funcio) {
			func = funcio;
		},
		pick: function(dades) {
			data = dades;
			func(data);
		},

		data : {}
	};
});




app.controller('CtrlPlantilla', ['$scope','$http','srvPlantilles', function($scope,$http,srvPlantilles) {

	$scope.counter = 0;
	$scope.items = {};

	$http.get('/api/plantilla')
			.then(function (result) {
				srvPlantilles.pick(result.data);
				$scope.items = result.data;
			});


	$scope.canvivalor = function(plant) {
	};

}]);


app.controller('mainController', ['$scope','$http','$sce','srvPlantilles', function($scope,$http,$sce,srvPlantilles){
	$scope.newDat = {};
	$scope.dats = {};
	$scope.selected = false;
	$scope.plantilles = {};
	$scope.plantillaActual;
	$scope.missatge = "aixó es un missatge";
	$scope.html = '<a ng-click="click(1)" href="#">Click me</a>';
	srvPlantilles.set(function(data) {
		$scope.plantilles=data;
	});

	$scope.click = function(arg) {
		alert('Clicked ' + arg);
	}

	$http.get('/api/activitat')
			.success(function(data) {

				$scope.dats = data;
			})
			.error(function(data) {
				console.log('Error: ' + data);
			});

	$scope.registrar = function(url) {
		$http.post(url, $scope.newDat)
				.success(function(data) {
					$scope.newDat = {};
					$scope.dats = data;
				})
				.error(function(data) {
					console.log('Error: ' + data);
				});
	};


	$scope.modificar = function(url,newDat) {
		$http.put(url + $scope.newDat._id, $scope.newDat)
				.success(function(data) {
					$scope.newDat = {}; // Borramos los datos del formulario
					$scope.dats = data;
					$scope.selected = false;
				})
				.error(function(data) {
					console.log('Error: ' + data);
				});
	};

	$scope.borrar = function(url,newDat) {
		$http.delete(url + $scope.newDat._id)
				.success(function(data) {
					$scope.newDat = {};
					$scope.dats = data;
					$scope.selected = false;
				})
				.error(function(data) {
					console.log('Error: ' + data);
				});
	};


		$scope.select = function(dat) {

			var id = dat.pattern;
			var arr = $scope.plantilles;
			for (var d = 0, len = arr.length; d < len; d += 1) {
				if (arr[d]._id === id) {
					$scope.plantillaActual = arr[d];
					break;
				}
			}
			$scope.newDat = dat;
			$scope.selected = true;
		};

	}]);


