angular.module('MainApp', [])

/**************************************************************************************
 *  Plantilles *
**************************************************************************************/

function mainController_plantilla($scope, $http) {
	$scope.newPlantilla = {};
	$scope.plantillas = {};
	$scope.selected = false;

	// Obtenemos todos los datos de la base de datos
	$http.get('/api/plantilla').success(function(data) {
		$scope.plantillas = data;
	})
	.error(function(data) {
		console.log('Error: ' + data);
	});


	// Función para registrar a una plantilla
	$scope.registrarPlantilla = function() {
		$http.post('/api/plantilla', $scope.newPlantilla)
		.success(function(data) {
				$scope.newPlantilla = {}; // Borramos los datos del formulario
				$scope.plantillas = data;
			})
		.error(function(data) {
			console.log('Error: ' + data);
		});
	};

	// Función para editar los datos de una plantilla
	$scope.modificarPlantilla = function(newPlantilla) {
		$http.put('/api/plantilla/' + $scope.newPlantilla._id, $scope.newPlantilla)
		.success(function(data) {
				$scope.newPlantilla = {}; // Borramos los datos del formulario
				$scope.plantillas = data;
				$scope.selected = false;
			})
		.error(function(data) {
			console.log('Error: ' + data);
		});
	};

	// Función que borra un objeto plantilla conocido su id
	$scope.borrarPlantilla = function(newPlantilla) {
		$http.delete('/api/plantilla/' + $scope.newPlantilla._id)
		.success(function(data) {
			$scope.newPlantilla = {};
			$scope.plantillas = data;
			$scope.selected = false;
		})
		.error(function(data) {
			console.log('Error: ' + data);
		});
	};

	// Función para coger el objeto seleccionado en la tabla
	$scope.selectPlantilla = function(plantilla) {
		$scope.newPlantilla = plantilla;
		$scope.selected = true;
		console.log($scope.newPlantilla, $scope.selected);
	};
}