var Usuari = require('./models/usuari');
var Plantilla = require('./models/plantilla');
var Activitat = require('./models/activitat');
var Controller = require ('./controller');
var multer     		=       require('multer');
var upload 			= 		multer({ dest: './uploads/'});


module.exports = function(app,db) {


	app.use(multer({ dest: './uploads/',
		rename: function (fieldname, filename) {
			return filename /*+Date.now()*/;
		},
		onFileUploadStart: function (file) {
			console.log(file.originalname + ' is starting ...');
		},
		onFileUploadComplete: function (file) {
			console.log(file.fieldname + ' uploaded to  ' + file.path)
		}
	}));

	app.get('/',function(req,res){
		res.sendFile(__dirname + "/index.html");
	});

	app.post('/api/photo',function(req,res){
		upload(req,res,function(err) {
			if(err) {
				return res.end("Error uploading file.");
			}
			res.end("File is uploaded");
		});
	});




	/***** Activitats ******/

	app.get('/api/activitat', Controller.getActivitat);
	app.post('/api/activitat', Controller.setActivitat);
	app.put('/api/activitat/:_id', Controller.updateActivitat);
	app.delete('/api/activitat/:_id', Controller.removeActivitat);

	/***** Plantilles ******/

	app.get('/api/plantilla', Controller.getPlantilla);
	app.post('/api/plantilla', Controller.setPlantilla);
	app.put('/api/plantilla/:_id', Controller.updatePlantilla);
	app.delete('/api/plantilla/:_id', Controller.removePlantilla);

	/***** Usuaris ******/

	app.get('/api/usuari', Controller.getUsuari);
	app.post('/api/usuari', Controller.setUsuari);
	app.put('/api/usuari/:_id', Controller.updateUsuari);
	app.delete('/api/usuari/:_id', Controller.removeUsuari);


	/***** Aplicació ******/

	app.get('/', function(req, res) {
		var st = req.originalUrl;
		var dir = process.cwd();
		res.sendFile(dir+"/index_join.html"); // Carga única de la vista
	});
};