'use strict';

angular.module('joinApp')
    .controller('MainCtrl', ['$scope', '$rootScope', '$window', '$location','ActivitatActiva', function ($scope, $rootScope, $window, $location,ActivitatActiva) {
        $scope.slide = '';
        $rootScope.back = function() {
          $scope.slide = 'slide-right';
          $window.history.back();
        };
        $rootScope.go = function(path,activitat){
            ActivitatActiva.set(activitat);
          $scope.slide = 'slide-left';
          $location.url(path);
        };
    }])

    /** Punt d'entrada del controlador. Aquí és fa la recepció de les plantilles i de les activitats del servidor */

    .controller('ActivitatsCtrl', ['$scope','$resource','plantilles',function ($scope,$resource,plantilles) {
        $resource("/api/activitat").query().$promise.then(function(data) {
            $scope.activitats = data;
        });
        $resource("/api/plantilla").query().$promise.then(function(data) {
            plantilles.set(data);
        });
    }])


    .controller('ActivitatCtrl', ['$scope','$resource', '$routeParams','$http', 'ActivitatActiva','table','plantilles', function ($scope, $resource,$routeParams, $http,ActivitatActiva,table,plantilles) {
        $scope.tableProperties  = {
            name : ""
        };


        $(document).ready(function() {
            $('#uploadForm').submit(function() {
                $("#status").empty().text("Pujant fitxer..");

                $(this).ajaxSubmit({

                    error: function(xhr) {
                        status('Error: ' + xhr.status);
                    },

                    success: function(response) {
                        console.log(response)
                        $("#status").empty().text(response);
                    }
                });

                return false;
            });
        });


        $scope.newActivitat = ActivitatActiva.get();
        $scope.tbActivitats = { };
        var nc = $scope.newActivitat;

        if (typeof $scope.newActivitat != 'undefined') {
            var _id = $scope.newActivitat.pattern;

            $scope.plantillaActual = {};
            var obj = plantilles.get();

            for (var i = 0; i < obj.length; i++) {
                // look for the entry with a matching `code` value
                if (obj[i]._id == _id) {
                    $scope.plantillaActual = obj[i];
                }
            }
        }

        $scope.uploadImage = function(newDat) {
            table.upload();
        }

        $scope.create = function(newDat) {
            table.create($scope.tableProperties,newDat);
        };
        $scope.update = function(newDat) {
            table.update($scope.tableProperties,newDat);
        };
        $scope.delete = function(newDat) {
            table.delete($scope.tableProperties,newDat);
        };
    }])

    .controller('PlantillaCtrl', ['$scope','$resource', '$routeParams','$http', 'ActivitatActiva','table', function ($scope, $resource,$routeParams, $http,ActivitatActiva,table) {
        $scope.plantillas = [];
        $scope.tableProperties  = {
            name : ""
        };
        $scope.newPlantilla = {};

        $http.get("/api/plantilla/").success(function(data) {
                $scope.plantillas = data;
            })
            .error(function(data) {
                console.log('Error: ' + data);
            });



        $scope.create = function(newDat) {
            table.create($scope.tableProperties,newDat);
        };
        $scope.update = function(newDat) {
            table.update($scope.tableProperties,newDat);
        };
        $scope.delete = function(newDat) {
            table.delete($scope.tableProperties,newDat);
        };
        $scope.select = function(plantilla) {
            $scope.newPlantilla = plantilla;
            $scope.selected = true;
            console.log($scope.newPlantilla, $scope.selected);
        };

    }])

    .controller('ReportListCtrl', ['$scope', '$routeParams', 'Report', function ($scope, $routeParams, Report) {
        $scope.activitats = Report.query({activitatId: $routeParams.activitatId});
    }]);
