'use strict';

var app = angular.module('joinApp');


app.directive('back', function factory($window) {
    return {
        restrict   : 'E',
        replace    : true,
        transclude : true,
        link: function (scope, element, attrs) {
            scope.navBack = function() {
                $window.history.back();
            };
        }
    };
});

app.directive('file', function(){
    return {
        scope: {
            file: '='
        },
        link: function(scope, el, attrs){
            el.bind('change', function(event){
                var files = event.target.files;
                var file = files[0];
                scope.file = file ? file.name : undefined;
                scope.$apply();
            });
        }
    };
});


app.directive('dynamic', function ($compile) {
    return {
        restrict: 'A',
        replace: true,
        link: function (scope, ele, attrs) {
            scope.$watch(attrs.dynamic, function(html) {
                ele.html(html);
                $compile(ele.contents())(scope);
            });
        }
    };
});


app.factory('table', ['$http',
     function ($http) {
         var self = this;
         self.data = {};
         var cmd = '/upload';

         var myData = {
             content_text: $('#contentText').val(),
             name: $('#Name').val(),
             event_id: $('#eventId').val()
         };

         self.bd = {
             upload : function (properties,newDat) {
                 $http.post(cmd, myData)
                     .success(function (data) {
                         console.log('Gravat Correctament: ' + data);
                     })
                     .error(function (data) {
                         console.log('Error: ' + data);
                     });
             },
             update: function (properties,newDat) {
                 $http.put(properties.name + newDat._id, newDat)
                     .success(function (data) {
                         console.log('Gravat Correctament: ' + data);
                     })
                     .error(function (data) {
                         console.log('Error: ' + data);
                     });
             },

             create : function (properties,newDat) {
                 $http.post(properties.name, newDat)
                     .success(function (data) {
                         console.log('Creat: ' + data);
                     })
                     .error(function (data) {
                         console.log('Error: ' + data);
                     });
             },
             delete :  function (properties,newDat) {
                $http.delete(properties.name + newDat._id)
                 .success(function(data) {
                     console.log('Deleted : ' + data);
                 })
                 .error(function(data) {
                     console.log('Error: ' + data);
                 });
         }




         }
     return self.bd;
    }]);